"use strict";

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _enjoyWebSupport = require("enjoy-web-support");

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TIMESTAMP_HASH_KEY = "timestamp";

// 解析url
function parseUrl(url, util) {
	url = url.split("?");

	var params = function (queryString) {
		var params = {};
		if (queryString) {
			queryString.split("&").forEach(function (item) {
				item = item.split("=");
				params[item[0]] = item[1];
			});
		}
		return params;
	}(url[1]);

	url = url[0];

	return {
		// header: routes[util.resolve(url).replace(/\.js$/, "")],
		component: util.require(url),
		params: params
	};
}

var RouterCore = function (_Router$Core) {
	_inherits(RouterCore, _Router$Core);

	function RouterCore() {
		_classCallCheck(this, RouterCore);

		return _possibleConstructorReturn(this, (RouterCore.__proto__ || Object.getPrototypeOf(RouterCore)).apply(this, arguments));
	}

	_createClass(RouterCore, [{
		key: "loadPage",

		// 根据当前url绘制页面
		value: function loadPage() {
			var _this2 = this;

			var url = _enjoyWebSupport.History.url;
			var timestamp = _enjoyWebSupport.Hash.get(TIMESTAMP_HASH_KEY);
			var historys = this.history;

			if (this.isReplace && historys[historys.length - 1] && historys[historys.length - 1].page) {
				// 如果是替换页面，并且不是第一个页面
				var replacePage = historys.pop();
				var currentPage = {
					url: url,
					timestamp: timestamp
				};

				historys.push(currentPage);

				// 通过url解析出跳转页面数据
				var router = parseUrl(this.map(url), this.util);

				_asyncToGenerator(regeneratorRuntime.mark(function _callee() {
					var component, header;
					return regeneratorRuntime.wrap(function _callee$(_context) {
						while (1) {
							switch (_context.prev = _context.next) {
								case 0:
									_context.next = 2;
									return router.component;

								case 2:
									component = _context.sent;
									header = _this2.getHeader(_this2.map(url), _this2.util);

									_this2.navbar.target.checkHeader(header, _this2, false);

									_enjoyWebSupport.React.unmountComponentAtNode(_this2.container);
									currentPage.page = _enjoyWebSupport.React.render(_enjoyWebSupport.React.createElement(component, _extends({
										navigator: _this2,
										_pageInfo: {
											navigator: _this2,
											url: url,
											referrer: replacePage.url //replacedUrl
										}
									}, router.params)), _this2.container);

									if (replacePage.page && replacePage.page.onForwardTo) {
										replacePage.page.onForwardTo(_this2.reverseMap(url, _this2.util));
									}

								case 8:
								case "end":
									return _context.stop();
							}
						}
					}, _callee, _this2);
				}))();
			} else if (historys.length > 1 && url === historys[historys.length - 2].url && timestamp === historys[historys.length - 2].timestamp) {
				// 后退
				// 当要跳转的页面是历史记录的上一个页面时，直接后退
				var prevPage = historys.pop();

				var _currentPage = historys[historys.length - 1];

				if (prevPage.page && prevPage.page.onBackTo) {
					prevPage.page.onBackTo(url);
				}

				// 通过url解析出跳转页面数据
				var _router = parseUrl(this.map(url), this.util);

				_asyncToGenerator(regeneratorRuntime.mark(function _callee2() {
					var component, header;
					return regeneratorRuntime.wrap(function _callee2$(_context2) {
						while (1) {
							switch (_context2.prev = _context2.next) {
								case 0:
									_context2.next = 2;
									return _router.component;

								case 2:
									component = _context2.sent;
									header = _this2.getHeader(_this2.map(url), _this2.util);

									_this2.navbar.target.checkHeader(header, _this2, true);

									_enjoyWebSupport.React.unmountComponentAtNode(_this2.container);
									_currentPage.page = _enjoyWebSupport.React.render(_enjoyWebSupport.React.createElement(component, _extends({
										navigator: _this2,
										_pageInfo: {
											navigator: _this2,
											url: url
											//,referrer: prevPage ? prevPage.url : ""
										}
									}, _router.params)), _this2.container);

									if (_currentPage.page.onBackFrom) {
										_currentPage.page.onBackFrom(prevPage.url);
									}

								case 8:
								case "end":
									return _context2.stop();
							}
						}
					}, _callee2, _this2);
				}))();
			} else {
				// 跳转新页
				var _currentPage2 = {
					url: url,
					timestamp: timestamp
				};
				historys.push(_currentPage2);
				// 将当前容器切换到上一个视图
				var _prevPage = historys[historys.length - 2];

				_asyncToGenerator(regeneratorRuntime.mark(function _callee3() {
					var router, component, header;
					return regeneratorRuntime.wrap(function _callee3$(_context3) {
						while (1) {
							switch (_context3.prev = _context3.next) {
								case 0:
									// 通过url解析出跳转页面数据
									router = parseUrl(_this2.map(url), _this2.util);
									// 渲染新页面

									_context3.next = 3;
									return router.component;

								case 3:
									component = _context3.sent;
									header = _this2.getHeader(_this2.map(url), _this2.util);

									_this2.navbar.target.checkHeader(header, _this2, false);

									_enjoyWebSupport.React.unmountComponentAtNode(_this2.container);
									// 渲染当前页面
									_currentPage2.page = _enjoyWebSupport.React.render(_enjoyWebSupport.React.createElement(component, _extends({
										navigator: _this2,
										_pageInfo: {
											navigator: _this2,
											url: url,
											referrer: _prevPage ? _prevPage.url : ""
										}
									}, router.params)), _this2.container);

									if (_prevPage && _prevPage.page && _prevPage.page.onForwardTo) {
										_prevPage.page.onForwardTo(_this2.reverseMap(url, _this2.util));
									}

								case 9:
								case "end":
									return _context3.stop();
							}
						}
					}, _callee3, _this2);
				}))();
			}

			this.isReplace = false;
		}
	}]);

	return RouterCore;
}(_enjoyWebSupport.Router.Core);

// iPhone6 plus中的微信，由于内存闪退问题，使用无动画版Router


if (/iPhone/i.test(navigator.userAgent) && screen.availWidth === 414 && screen.availHeight === 736) {
	_enjoyWebSupport.Router.Core = RouterCore;
}