"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _weixin = require("../lib/weixin");

var _weixin2 = _interopRequireDefault(_weixin);

var _wxSign = require("../lib/wxSign");

var _wxSign2 = _interopRequireDefault(_wxSign);

var _enjoyWebSupport = require("enjoy-web-support");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

function transPosition(position, info) {
	var city = info.addressComponent.city;
	var province = info.addressComponent.province;
	if (city instanceof Array) {
		city = city[0];
	}
	city = city || province;

	return {
		lat: position.latitude,
		lng: position.longitude,
		accuracy: position.accuracy,
		speed: position.speed,
		address: info.formatted_address,
		country: info.addressComponent.country,
		province: province,
		city: city.replace(/市$/, ""),
		district: info.addressComponent.district,
		streetName: info.addressComponent.streetNumber.street,
		streetNumber: info.addressComponent.streetNumber.number
	};
}

var geting = false;
var list = [];

exports.default = {
	TIMEOUT: 6000, //wxjsdk 下载 超时时间增加3s

	get: function get() {
		return (0, _enjoyWebSupport.Promise)(function (resolve, reject) {
			list.push(function (position, info) {
				if (info.info === "OK") {
					resolve(transPosition(position, info.regeocode));
				} else {
					reject({
						message: ""
					});
				}
			});

			if (!geting) {
				geting = true;

				_weixin2.default.ready(function () {
					wx.getLocation({
						type: 'wgs84', // 默认为wgs84的gps坐标，如果要返回直接给openLocation用的火星坐标，可传入'gcj02'
						success: function () {
							var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(position) {
								var info;
								return regeneratorRuntime.wrap(function _callee$(_context) {
									while (1) {
										switch (_context.prev = _context.next) {
											case 0:
												_context.next = 2;
												return (0, _enjoyWebSupport.Fetch)(location.protocol + ("//restapi.amap.com/v3/geocode/regeo?output=json&location=" + position.longitude + "," + position.latitude + "&key=57d825abc441bf9851138bd1581567e6"));

											case 2:
												info = _context.sent;

												// if(info.info === "OK"){
												// 	resolve(transPosition(position, info.regeocode));
												// }else{
												// 	reject({
												// 		message: ""
												// 	});
												// }
												list.forEach(function (item) {
													item(position, info);
												});
												list = [];
												geting = false;

											case 6:
											case "end":
												return _context.stop();
										}
									}
								}, _callee, this);
							}));

							function success(_x) {
								return _ref.apply(this, arguments);
							}

							return success;
						}(),
						fail: function fail(ex) {
							alert(JSON.stringify(ex));
						}
					});
				});
			}
		}, this.TIMEOUT);
	},
	watch: function watch(listener) {},
	clearWatch: function clearWatch() {}
};