"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = function (params) {

	if (!layer) {
		layer = new _enjoyWebSupport.Layer.LayerClass(ShareUI, {
			hashKey: "share"
		});
	}

	return new Promise(function (resolve, reject) {
		//更新签名
		!params ? reject({ message: '请调用合法参数' }) : typeof params.platformType !== "number" ? 2 : params.platformType;

		_weixin2.default.ready(function () {
			var plattformMenu = {
				0: ['menuItem:share:appMessage', "menuItem:favorite"],
				1: ['menuItem:share:appMessage', 'menuItem:share:timeline', "menuItem:favorite"],
				2: ['menuItem:share:appMessage', 'menuItem:share:timeline', 'menuItem:share:qq', 'menuItem:share:QZone', "menuItem:favorite"]
			};
			wx.hideAllNonBaseMenuItem();
			wx.showMenuItems({
				menuList: plattformMenu[params.platformType]
			});
			//分享到朋友圈
			if (params.platformType >= 1) {
				wx.onMenuShareTimeline({
					trigger: function trigger() {
						this.title = params.shareDic.wxFriendTitle;
						this.link = params.shareDic.shareLink;
						this.imgUrl = params.shareDic.shareThumbImageUrl;
					},
					success: function success(res) {
						resolve(true);
					},
					fail: function fail(res) {
						reject(res);
					},
					cancel: function cancel(res) {
						reject({ message: "用户取消" });
					},
					compete: function compete(res) {
						setTimeout(function () {
							layer.hide();
						}, 3000);
					}
				});
			}
			//分享给朋友
			if (params.platformType >= 0) {
				wx.onMenuShareAppMessage({
					trigger: function trigger() {
						this.title = params.shareDic.wxShareTitle;
						this.desc = params.shareDic.wxShareMessage;
						this.link = params.shareDic.shareLink;
						this.imgUrl = params.shareDic.shareThumbImageUrl;
					},
					success: function success(res) {
						resolve(true);
					},
					fail: function fail(res) {
						reject(res);
					},
					cancel: function cancel(res) {
						reject({ message: "用户取消" });
					},
					compete: function compete(res) {
						setTimeout(function () {
							layer.hide();
						}, 3000);
					}
				});
			}
			//分享给qq好友
			if (params.platformType >= 2) {
				wx.onMenuShareQQ({
					trigger: function trigger() {
						this.title = params.shareDic.qqShareTitle;
						this.desc = params.shareDic.qqShareMessage;
						this.link = params.shareDic.shareLink;
						this.imgUrl = params.shareDic.shareThumbImageUrl;
					},
					success: function success(res) {
						resolve(true);
					},
					fail: function fail(res) {
						reject(res);
					},
					cancel: function cancel(res) {
						reject({ message: "用户取消" });
					},
					compete: function compete(res) {
						setTimeout(function () {
							layer.hide();
						}, 3000);
					}
				});
				//分享到qq空间
				wx.onMenuShareQZone({
					trigger: function trigger() {
						this.title = params.shareDic.qqShareTitle;
						this.desc = params.shareDic.qqShareMessage;
						this.link = params.shareDic.shareLink;
						this.imgUrl = params.shareDic.shareThumbImageUrl;
					},
					success: function success(res) {
						resolve(true);
					},
					fail: function fail(res) {
						reject(res);
					},
					cancel: function cancel(res) {
						reject({ message: "用户取消" });
					},
					compete: function compete(res) {
						setTimeout(function () {
							layer.hide();
						}, 3000);
					}
				});
			}
			layer.show();
		});
	});
};

var _enjoyWebSupport = require("enjoy-web-support");

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _weixin = require("../../lib/weixin");

var _weixin2 = _interopRequireDefault(_weixin);

var _wxSign = require("../../lib/wxSign");

var _wxSign2 = _interopRequireDefault(_wxSign);

var _index = require("./index-css");

var _index2 = _interopRequireDefault(_index);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var layer;

var ShareUI = function (_Component) {
	_inherits(ShareUI, _Component);

	function ShareUI(props) {
		_classCallCheck(this, ShareUI);

		return _possibleConstructorReturn(this, (ShareUI.__proto__ || Object.getPrototypeOf(ShareUI)).call(this, props));
	}

	_createClass(ShareUI, [{
		key: "componentDidMount",
		value: function componentDidMount() {}
	}, {
		key: "render",
		value: function render() {
			return _react2.default.createElement("div", { "className": "share-pop", style: styles.share });
		}
	}]);

	return ShareUI;
}(_enjoyWebSupport.Component);

var styles = {
	share: {
		top: 158 - _enjoyWebSupport.Screen.size.height
	}
};